<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt';
import type { Receipt } from '@/types/Receipt';
import { type Ref, inject, ref, onMounted, watch, toRefs } from 'vue';
import { useMemberStore } from '@/stores/member';
const receiptStore = useReceiptStore()
const memberStore = useMemberStore()

const formatDate = (date: Date) => date.toLocaleDateString('th-TH', {
    year: '2-digit',
    month: '2-digit',
    day: '2-digit'
});
const formatTime = (date: Date) => date.toLocaleTimeString('th-TH');

const currentDate = ref(new Date());
const formattedDate = formatDate(currentDate.value);
const currentTime = formatTime(currentDate.value);
onMounted(() => {
    const intervalId = setInterval(() => {
        currentDate.value = new Date();
    }, 1000);


    return () => clearInterval(intervalId);


});
const { change } = toRefs(receiptStore.receipt);

watch(change, (newVal) => {
    receiptStore.receipt.change = newVal;
});

watch(() => receiptStore.receipt.cash - receiptStore.receipt.total, (newVal) => {
    change.value = newVal;
});
const saveAndCloseDialog = () => {
  receiptStore.saveReceipt();
  receiptStore.receiptDialog = false;
}

</script>

<template>
    <v-dialog v-model="receiptStore.receiptDialog" persistent width="auto">
        <v-card>
            <div style="margin-top: 40px; align-self: center;">
                <v-img style="width: 70px; margin-left: 10px;"
                    src="https://cdn-icons-png.flaticon.com/512/924/924514.png"></v-img>
                <v-card-text style="">D-Coffee</v-card-text>
            </div>
            <v-card-text style="">สาขา บางแสน ที่อยู่ D-Coffee BUU </v-card-text>
            <v-card-text>
                รายการออเดอร์: {{ receiptStore.receipt.id + 1 }} <br>
                วันที่: {{ formattedDate }} <br>
                เวลา: {{ currentTime }} <br>
                แคชเชียร์: {{ receiptStore.receipt.user?.fullname }} <br>
                ชื่อลูกค้า: {{ memberStore.currentMember?.name }}<br>
                ----------------------------------------------------------
            </v-card-text>
            <v-card-text>
                <p v-for="(item, index) in receiptStore.receipt.receiptItems" :key="index">
                    <v-row>
                        <v-col>
                            {{ item.unit }}
                        </v-col>
                        <v-col cols="">
                            {{ item.name }}
                        </v-col>
                        <v-col cols="3">
                            {{ item.price * item.unit }}
                        </v-col>
                    </v-row>
                </p>
                <br>
                ----------------------------------------------------------
                <br>
                <v-row>
                    <v-col>
                        SUBTOTAL <br>
                        TOTAL <br>
                        Cash <br>
                        Change <br>
                    </v-col>
                    <v-col cols="3">
                        {{ receiptStore.receipt.totalBefore }} <br>
                        {{ receiptStore.receipt.total }} <br>
                        {{ receiptStore.receipt.cash }} <br>
                        {{ receiptStore.receipt.change }}
                    </v-col>
                </v-row>
                <br>
                <p style="font-size: 16pt; font-family: Roboto; text-align: center;">Thank You</p>
            </v-card-text>
            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="green-darken-1" variant="text" @click="receiptStore.receiptDialog = false">
                    ปิด
                </v-btn>
                <v-btn color="green-darken-1" variant="text" @click="saveAndCloseDialog"  >
                    บันทึก
                </v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>
